// 
// 

// 
// Copyright (c) 2003-2010, MIST Project, Nagoya University
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
// 
// 3. Neither the name of the Nagoya University nor the names of its contributors
// may be used to endorse or promote products derived from this software
// without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
// IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
// THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 

// generated by Fast Light User Interface Designer (fluid) version 1.0106

#ifndef ct_image_window_h
#define ct_image_window_h
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Button.H>

class parameter_window {
public:
  parameter_window();
  Fl_Double_Window *param_window;
  Fl_Value_Input *width;
  Fl_Value_Input *height;
  Fl_Value_Input *depth;
  Fl_Value_Input *sizeX;
  Fl_Value_Input *sizeY;
  Fl_Value_Input *sizeZ;
  Fl_Value_Input *offset;
  Fl_Return_Button *OK;
private:
  inline void cb_OK_i(Fl_Return_Button*, void*);
  static void cb_OK(Fl_Return_Button*, void*);
public:
  Fl_Button *Cancel;
private:
  inline void cb_Cancel_i(Fl_Button*, void*);
  static void cb_Cancel(Fl_Button*, void*);
  int val;
public:
  int value();
  void hide();
  bool show();
};
#include <FL/Fl_Group.H>
#include "raw_test.h"
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Progress.H>

class ct_image_window {
public:
  ct_image_window( );
  Fl_Double_Window *image_window;
  ct_draw_area *ct_image;
  static Fl_Menu_Item menu_[];
private:
  inline void cb_Open_i(Fl_Menu_*, void*);
  static void cb_Open(Fl_Menu_*, void*);
  inline void cb_Save_i(Fl_Menu_*, void*);
  static void cb_Save(Fl_Menu_*, void*);
  inline void cb_Median_i(Fl_Menu_*, void*);
  static void cb_Median(Fl_Menu_*, void*);
  inline void cb_Median1_i(Fl_Menu_*, void*);
  static void cb_Median1(Fl_Menu_*, void*);
  inline void cb_Median2_i(Fl_Menu_*, void*);
  static void cb_Median2(Fl_Menu_*, void*);
  inline void cb_Normalization_i(Fl_Menu_*, void*);
  static void cb_Normalization(Fl_Menu_*, void*);
  inline void cb_Euclidean_i(Fl_Menu_*, void*);
  static void cb_Euclidean(Fl_Menu_*, void*);
  inline void cb_Labeling_i(Fl_Menu_*, void*);
  static void cb_Labeling(Fl_Menu_*, void*);
  inline void cb_Labeling1_i(Fl_Menu_*, void*);
  static void cb_Labeling1(Fl_Menu_*, void*);
  inline void cb_Thinning_i(Fl_Menu_*, void*);
  static void cb_Thinning(Fl_Menu_*, void*);
  inline void cb_Thinning1_i(Fl_Menu_*, void*);
  static void cb_Thinning1(Fl_Menu_*, void*);
  inline void cb_Erosion_i(Fl_Menu_*, void*);
  static void cb_Erosion(Fl_Menu_*, void*);
  inline void cb_Dilation_i(Fl_Menu_*, void*);
  static void cb_Dilation(Fl_Menu_*, void*);
  inline void cb_Opening_i(Fl_Menu_*, void*);
  static void cb_Opening(Fl_Menu_*, void*);
  inline void cb_Closing_i(Fl_Menu_*, void*);
  static void cb_Closing(Fl_Menu_*, void*);
  inline void cb_Figure_i(Fl_Menu_*, void*);
  static void cb_Figure(Fl_Menu_*, void*);
public:
  Fl_Value_Slider *WL;
private:
  inline void cb_WL_i(Fl_Value_Slider*, void*);
  static void cb_WL(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *WW;
private:
  inline void cb_WW_i(Fl_Value_Slider*, void*);
  static void cb_WW(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *Indx;
private:
  inline void cb_Indx_i(Fl_Value_Slider*, void*);
  static void cb_Indx(Fl_Value_Slider*, void*);
public:
  Fl_Progress *progress_bar;
  void show();
};
#endif
